#ifndef __NEO_DIALOG_H__
#  define __NEO_DIALOG_H__

/*
     encapsulate window type in Neo's own type:
*/

typedef struct neo_dialog_{} neo_dialog_t;

typedef struct dialog_var_{
   char     *pcFormat;    /* short form of format string */
   int      iNumEntries, iNumVal, iTxtVal, iPatchLevel;
   int      *piNumSlot;   /* index table of numeric slots */
   float    *pfNumVal;    /* numeric default values in window */
   char     **ppcTxtVal;  /* text default values in window */
} dialog_var_t;

/* this must be same as in nst_tk_aux.h and in nst.h: */
/*
#define NST_BLANK_ENTRY (-100000)
*/
extern void          neo_bell(void);
extern neo_dialog_t *neo_info_box(char*);
extern void          neo_alert_box(char*);
extern neo_dialog_t *neo_choice_box(char *);
extern void          neo_remove_dialog(neo_dialog_t *);
extern neo_dialog_t *neo_query_window(char*,char*);
extern neo_dialog_t *neo_query_window1(char*,char*);
extern int           neo_query_loop(neo_dialog_t *);
extern neo_dialog_t *neo_dialog_copy(neo_dialog_t *, neo_dialog_t*);
extern int           neo_query_loop1(neo_dialog_t *, int);

extern char *neo_get_tval(int, neo_dialog_t*);
extern char *neo_get_tval_with_subst(int, neo_dialog_t*);
extern float neo_get_fval(int, neo_dialog_t*);
extern int   neo_get_ival(int, neo_dialog_t*);
extern int   neo_get_numvals(neo_dialog_t*);
extern int   neo_get_numtxts(neo_dialog_t*);
extern void  neo_set_ival(int, int, neo_dialog_t*);
extern void  neo_set_fval(int, float, neo_dialog_t*);
extern void  neo_set_tval(int, char*, neo_dialog_t*);
extern void  neo_set_widgets(neo_dialog_t*);
extern void  neo_update_dialog(neo_dialog_t*);
extern char *neo_dialog_format(neo_dialog_t*);

/* two utility macros to access values: */

#define BUTTON(W,AnyComment,i) (neo_get_ival((i),(W)) > 0)  
#define VALUE(W,AnyComment,i)  (neo_get_fval((i),(W)))     

#endif
