/*
 * $Id$
 */

#if !defined( SAY ) && ! defined ( _SAY )
#define _SAY
	/* 
	 *  USEFUL FOR DEBUGGING:
	 *	SAY("hallo world");
	 *	SAYS(("%s,%d", tDyn, iN ));
	 *
	 * CAUTION SAYS need double (( )) !
	 * before including this file you can define
	 * #define __THISFILE__ "src_file_name"
	 * in order to shorten the identifier name (w/o dir)
	 * default is the full name with relative path
	 */
#ifndef __THISFILE__		
#define __THISFILE__  __FILE__
#endif
#define SAY(x)	printf("IN %s:%d``%s''\n", __THISFILE__,__LINE__,(x))
#define SAYS(x) (printf("IN %s:%d ``", __THISFILE__,__LINE__),  \
			printf x, printf("''\n"))
#define PRINTFV(v,l) {int z;for(z=0;z<(l);z++)printf("%g ",v[z]);\
                      printf(" ::%s:%d\n",__THISFILE__,__LINE__);}
#endif

extern void aux_chi2_and_entropy_measure(
   int iNumRecords,  /* nr of records */
   int iDim,         /* dimension per record */
   float *pfVec,     /* data vector containing iNumRecords*iDim
                        elements */
   float *pfMin,     /* .iDim min values for binning */
   float *pfMax,     /* .iDim max values for binning */
   int   *piBins,    /* .iDim nr of bins to use */
   float *pfCramV,   /* iDim x iDim matrix of Cramers V */ 
   float *pfProb,    /* iDim x iDim matrix of significance levels for chi2 statistics */ 
   float *pfEntropy,  /* iDim x iDim matrix of computed
                        cross entropy values */
   float *pfDof,		/* DOF */
   float  *pfN			/* support */
);

extern int aux_chi2_and_entropy(
   int iRows, int iCols,	/* nr of rows and columns */
   float *pfCounts,		/* contains counts for iRows x iCols bins,
				   with row index = fast index */
   float *pfChi2,		/* return value: chi2 statistics */
   float *pfProb,		/* return value: significance level for correlation */ 
   float *pfCramV,		/* return value: Cramers V */ 
   float *pfHx,			/* return value: entropy of x-distr */
   float *pfHy,			/* return value: entropy of y-distr */
   float *pfHxy,		/* return value: total entropy */
   float *pfUxy,		/* return value: uncertainty coeff of x */
   float *pfUyx 		/* return value: uncertainty coeff of y var */
);

extern int aux_contingency_table(
   int iBins1, int iBins2,       /* nr of bins */
   float fMin1, float fMin2,     /* start of first bin */
   float fMax1, float fMax2,     /* end of last bin */
   float *pfVec1, float *pfVec2, /* data values to use */
   int iNum,                     /* their number */
   int iStride1, int iStride2,   /* their index spacing */
   float *pfResult /* iBins1 x iBins2 matrix of result values:
                    ij el contains nr of els in bin i bin j 
                  */
);

extern int aux_lincor_measure(
   int iNumRecords,  /* nr of records */
   int iDim,         /* dimension per record */
   float *pfVec,     /* data vector containing iNumRecords*iDim */
   float *pfCorr,    /* iDim x iDim matrix of lin corr coeff */ 
   float *pfSig,      /* iDim x iDim matrix of significance levels */ 
   float *pfA			/* OUT: linear corelation factor if!=NULL */

);

extern float aux_gammq(float a, float x) ;
extern float aux_betai(float a, float b, float x);
extern float aux_student_t(float fT, float fNumDof) ;

/* 
 * $Log$
 */



