/*****************************************************************************
 *
 * nst_adaptive.h  -  header for adaptive units
 *
 * Copyright Helge Ritter, 1994
 *
 * $Source$
 *
 * $Log$
 * Revision 1.2  1997/03/13  09:45:02  jan
 * New folder neuron added. Dependency adjustments made in other folders.
 *
 *
 *****************************************************************************/

#ifndef __NST_ADAPTIVE_H
#define __NST_ADAPTIVE_H

#define DY_in  in_1
#define DX_out out_1
#define WID_in in_4

#define NST_FREE_WEIGHTS -101
#define NST_PRUNE_WEIGHTS -102
#define NST_RANDOMIZE_WEIGHTS -103


extern unitptr hebb_unit(int n, float (*f)(float), int mode, unittype *dest);  
extern unitptr delta_unit(int n, int mode, unittype *dest);  
extern unitptr vq_unit(int,int,unitptr);
extern unitptr bp_unit(int n, float (*f)(float), float (*df)(float), 
         int mode, unittype *dest);
extern unitptr bp_layer(int din, int nodes, float(*f)(float),
			float(*df)(float), char *pcOpt, unittype *dest);
extern unitptr bp_net(int n, int l, int *h, float(*f)(float), float(*df)(float), unittype* u);
extern unitptr mlp_net(int inpins, int hlayers,
 int hnodes[], float(*f)(float), float(*df)(float), char *pcOpt, 
 unittype *dest);
extern unitptr delta_layer(int din, int nodes, int mode, unittype *dest);
extern unitptr rbf_layer(int din, int nodes, float (*f)(float), int mode, 
			 unittype *dest);
extern unitptr som_layer(int din, int dx, int dy, float (*f)(float), float (*h)(float), 
              int mode, unittype *dest);
extern unitptr llm_unit(int din, int dout, int nodes, unittype *dest);
extern unitptr llm_layer(int din, int dout, int n, int mode, unittype *dest);
extern unitptr llm_layer2(int din, int dout, int n, int mode, unittype *dest);
extern unitptr vq_layer(int, int, int, int, unitptr);

float *winptr(int, unittype*);
float *woutptr(int, unittype*);

extern unitptr competition(int n, int numf, float *beta, float (*f)(float), unittype *dest);

extern unitptr bp_layer1(int din, int nodes, float(*f)(float),
float(*df)(float), int mode, unittype *dest);

extern int nst_is_neuron_pool(unitptr);
 
extern float FUN_VOID(float);
extern float FUN_LOGISTIC(float);
extern float FUN_DLOGISTIC(float);
extern float FUN_MINUS1_2(float);
extern float FUN_CLIP1_2(float);
extern float FUN_SIGNEDSQUARE(float);
extern float RNDFUN_GAUSS(void);
extern float RNDFUN_GAUSS1(void);
extern float RNDFUN_UNIFORM01(void);
extern float RNDFUN_UNIFORM11(void);
extern float RNDFUN_BINARY01(void);
extern float RNDFUN_BINARY11(void);
extern float RNDFUN_GAUSS(void);
extern float RNDFUN_CONST1(void);
extern float FUN_REGINV(float fDistance);
extern float FUN_REGINV2(float fDistance);
extern float FUN_REGINV3(float fDistance);
extern float FUN_GAUSS1(float fDistance);
extern float FUN_BP(float,float,float);
extern float FUN_HEBB(float,float,float);
extern float FUN_WTA_HEBB(float,float,float);
extern float FUN_DELTA(float,float,float);
extern float FUN_WTA_DELTA(float,float,float);

#endif
