
/***********************************************************************

  include file nst_aux7.h: expression parsing 

  Copyright Helge Ritter, 1996

 * $Source$
 * $Log$
 * Revision 1.3  1997/04/02 14:08:28  helge
 * most man pages now in source code; some corrections;
 * for list, check out new log file in main dir
 *
 * Revision 1.2  1997/03/13  10:54:29  jan
 * Dependency cleanup.
 *
 * Revision 1.3  1997/01/20 13:46:41  helge
 * various minor changes.
 *
 * Revision 1.2  1997/01/14  14:24:42  helge
 * numerous small changes to take care of (almost) all warnings under
 * -Wall -O2.
 *
 * Revision 1.1  1996/08/07  14:47:30  helge
 * Initial revision
 *

***********************************************************************/

#ifndef __NST_AUX7_H
#define __NST_AUX7_H


typedef struct Instruc_{  /* code consists of sequences of this */
   int iOp;  /* which operation */
   int iM,iN,iM1,iN1,iAux;  /* up to 5 parameters for matrix operations */
   union { float f; float *pf; int iOffset; int n1;} Arg;  /* the arguments */
   /* NOTE: the n1 parameter must be = order of operator - 1!! */
} Instruc_t;

extern int        nst_init_token(char*);
extern int        nst_which_token(char*,...);
extern int        nst_next_token(void);
extern int        nst_is_token(char*);
extern char      *nst_get_token(void);
extern void       nst_unget_token(void);
extern char     **nst_tokenset(char **);
extern void       nst_begin_compile(Instruc_t*);
extern Instruc_t *nst_end_compile(int);
extern Instruc_t *nst_compile_bool(char*);
extern Instruc_t *nst_compile_arith(char*);
extern int        nst_numvar_of_code(Instruc_t*);
extern char      *nst_get_parsed(void);
extern char      *nst_get_unparsed(void);
extern float     *nst_create_stack_for(Instruc_t*);
extern float      nst_interprete(Instruc_t*,float**,float*);
extern char      *nst_get_parse_errinfo(void);
extern void       nst_set_parse_errinfo(char*,...);

#endif
