/*****************************************************************************
 *
 * nst_filter.h  -  header for image filtering and feature extraction units
 *
 * Copyright Helge Ritter, 1994
 *
 * $Source$
 *
 * $Log$
 * Revision 1.3  1997/04/02 14:02:49  helge
 * minor changes
 *
 * Revision 1.2  1997/03/13  09:45:05  jan
 * New folder neuron added. Dependency adjustments made in other folders.
 *
 *
 *****************************************************************************/

#ifndef __NST_FILTER_H
#define __NST_FILTER_H

extern int mkGaborGrid(int,float,int,float,float,float,int,
		       float,int,float,float*,float*,float*,
		       float*,float*); 
unitptr gabor_to_pic(int,int,int,float*,float*,float*,float*,float*,unitptr);
unitptr gabor_dual_to_pic(int,int,int,float*,float*,float*,float*,float*,unitptr);
unitptr pic_to_gabor(int,int,int,float*,float*,float*,float*,float*,unitptr);
unitptr threshold(int,int,float*,float*,int*,unitptr);
unitptr threshold_image(int,int,float,float,int,unitptr);
unitptr convolution(int,int,float*,int,int,unitptr);
extern unitptr laplace(int,int,unitptr);
extern unitptr sobel_x(int,int,unitptr);
extern unitptr sobel_y(int,int,unitptr);
extern unitptr gauss(int,int,float*,float*,unitptr);
extern unitptr gauss1(int,int,float,float,unitptr);
extern unitptr max_gauss(int,int,float,float,unitptr);
extern unitptr mexican(int,int,float*,float*,float*,float*,unitptr);
extern unitptr mexican1(int,int,float,float,float,float,unitptr);
extern unitptr median(int,int,unitptr);
extern unitptr box_filter(int,int,int,float*,char*,unitptr);
extern unitptr diff_segment(int,int,unitptr);

#endif
