/*********************************************************
 *
 *  JW out of nr made ansi type
 *  convert all KR-header to ansi and replace internal function def
 *  by include ing this file!!!  (math.h not needed)
 *  $Log$
 *  Revision 1.3  1997/04/02 14:10:30  helge
 *  most man pages now in source code; some corrections;
 *  for list, check out new log file in main dir
 *
 * Revision 1.2  1997/03/13  10:55:56  jan
 * Dependency cleanup.
 *
 *  Revision 1.6  1997/01/20 13:49:03  helge
 *  various minor changes.
 *
 * Revision 1.5  1995/09/21  11:05:49  walter
 * svd now in double precision, tCtrl added
 * adapt works in several options
 *
 *
 *	MAJOR CHANGE FROM float TO  double  precision!  svd.c -> dsvd.c
 *
 *  Revision 1.4  1995/07/31 09:23:33  helge
 *  some minor changes.
 *
 *  Revision 1.2  1995/07/16 20:55:25  helge
 *  enhanced rpc_unit to make remote units from neo's *.NST-files
 *  extended nst_rpd.c, nst_rpd_add accordingly [changes disabled by
 *  undefing NEO in nst_rpd_add.c]
 *  provided 8-bit versions of some nst-units [nst_math8 etc.]
 *
 * Revision 1.1  1994/09/04  17:26:30  walter
 * new psom2 files
 *
 * Revision 1.1  1994/08/26  07:01:10  walter
 * Initial revision
 *
 *********************************************************/
 
#ifndef  __NST_PSOM_AUX2_H
#define  __NST_PSOM_AUX2_H

#include <math.h>
#include <stdio.h>


/*********************************
	dsvd.h
 *********************************/
/****************************************************************************/

extern void  dsvbksb(	double **u, double *w, double **v, 
			int m, int n, double *b,double *x);
extern void  dsvdcmp(	double **a, int m, int n, double *w, double **v);
extern int   dsvdZeroW(	double *pdw, double dClipFactorOfMax, int i);

struct _DSVD_VARS_STRUCT {	
	int 	m;			/* matrix dimension m>=n */
	int	n;			/* matrix dimension */
	double	**ppdA;			/* decomposed matrix a[1..m][1..n] */
	double 	*pdW;			/* diagonal Matrix as w[1..n] */
	double	**ppdV;			/* Matrix v[1..n][1..n] */
	double	*pdA0ckeck;		/* C-like A Matrix pdA0[0..m*n-1]
		 characterizing info made by dsvdZeroWbyStruct() */
	double	dDet;			/* determinate of uncleaned svd */
	double	dDetRange;		/* determinate of zeroed svd */
	int	iNullity;		/* number of zeroed w[] */
	double 	dWmax;			/* largest w[] value (-1.0 not valid)*/
	double	dClipFactorOfMax;	/* zeroing factor  */
};
 typedef struct _DSVD_VARS_STRUCT DSVD_VARS_STRUCT;
 
extern DSVD_VARS_STRUCT *newDsvdVarsStruct(
	double 	*pdA0,		/* C-like matrix pdA0[0..n*m-1] */
	int	m,		/* matrix dimension m>=n */
	int	n);
    /*
	    DESCRIPTION:
	    set up a DSVD_VARS_STRUCT for holding all required tmp matrixes 
	    and pointer matrixes for singular value decomposition routines.
	    Make sure, that pdA0[] does not change its address since there 
	    is tmp pointer matrix build up in the returned structur.
    */
extern void	freeDsvdVarsStruct(DSVD_VARS_STRUCT *psOld);

extern int	dsvdcmpByStruct( DSVD_VARS_STRUCT *psA , double dClipFactorOfMax);
    /*	call dsvdcmp() on struct and zero w[] by calling dsvdZeroWbyStruct()  */
 
extern int dsvdZeroWbyStruct(DSVD_VARS_STRUCT *psA , double dClipFactorOfMax);

extern void	dsvbksbByStruct(DSVD_VARS_STRUCT *psA , double *pdX0result, double *pdB0); 
	/*
	Solves A.X=B for  pdX0result[0..n-1] and pdB0[0..m-1] where matrix A
	is spectified by the arrays u,w,v  as an internal result from calling
	dsvdcmpByStruct() before.
	This routine can be called repeated times.  pdX0result==pdB0 is ok.
	*/

extern int	checkDsvdVarsStruct(DSVD_VARS_STRUCT *psA , double *pdA);

extern int	solve_linsys0_dsvd(
	double	*pdX0result, 	/* result vector x */
	int	m,		/* matrix dimension m>=n */
	int	n,
	double 	*pdA0,		/* C-like matrix pdA0[0..n*m-1] */
	double	*pdB0,		/* B-vector */
	double	dClipFactorOfMax /* zeros off noisy nullspace if >0.0 */
	);
	
extern double	**convert_dmatrix(double *a, long nrl, long nrh, long ncl, long nch);
/* 
    allocate a double matrix m[nrl..nrh][ncl..nch] that points to the matrix
    declared in the standard C manner as a[nrow][ncol], where nrow=nrh-nrl+1
    and ncol=nch-ncl+1. The routine should be called with the address
    &a[0][0] as the first argument.
*/

extern void	free_convert_dmatrix(double **b, long nrl, long nrh, long ncl, long nch);

/* END of dsvd.h ********************************************************/


/**************************************************** UTIL *******/

extern void nrerror(char * error_text);
extern float *vector(int nl, int nh);
extern int *ivector(int nl, int nh);
extern double *dvector(int nl, int nh);

extern float **matrix(int nrl, int nrh, int ncl, int nch);
extern double **dmatrix(int nrl, int nrh, int ncl, int nch);
extern int **imatrix(int nrl, int nrh, int ncl, int nch);
extern float **submatrix(float ** a, int oldrl, int oldrh, 
	    int oldcl, int oldch, int newrl, int newcl);

extern void free_vector(float * v, int nl, int nh);
extern void free_ivector(int *v, int nl, int nh);
extern void free_dvector(double * v, int nl, int nh);
extern void free_matrix(float **m, int nrl, int nrh, int ncl, int nch);
extern void free_dmatrix(double **m, int nrl, int nrh, int ncl, int nch);
extern void free_imatrix(int **m, int nrl, int nrh, int ncl, int nch);
extern void free_submatrix(float **b, int nrl, int nrh, int ncl, int nch);

extern float **convert_matrix(float *a, int nrl, int nrh, int ncl, int nch) ;

extern void free_convert_matrix(float **b, int nrl, int nrh, int ncl, int nch);




#endif
