/*****************************************************************************
 *
 * nst_string.h  -  header for string handling units
 *
 * Copyright Helge Ritter, 1995
 *
 * $Source$
 *
 * $Log$
 * Revision 1.7  1999/02/01 10:23:19  helge
 * added new unit vec_to_str; former str_to_vec now accepts dim=0 to make
 * dynamic result vector.
 *
 * Revision 1.6  1997/09/28 18:14:08  helge
 * minor corrections for SRCLINEs and header defs
 *
 * Revision 1.5  1997/08/26 15:47:18  jan
 * Missing external declaration added.
 *
 * Revision 1.4  1997/08/23 22:39:57  helge
 * some additional string operations
 *
 * Revision 1.3  1997/04/02  14:03:03  helge
 * minor changes
 *
 * Revision 1.2  1997/03/13  09:45:20  jan
 * New folder neuron added. Dependency adjustments made in other folders.
 *
 *
 *****************************************************************************/

#ifndef __NST_STRING_H
#define __NST_STRING_H

extern FILE *fopen_with_share(char*,char*);
extern void fclose_with_share(FILE*);

extern unitptr str_dist(unitptr);
extern unitptr const_str(char*,unitptr);
extern unitptr printf_unit(FILE*,char*,int,unitptr);
extern unitptr scanf_unit(FILE*,char*,int,unitptr);
extern unitptr scanf_op(int,FILE*,char*,int,unitptr);
extern unitptr str_scanf_op(int,char*,char*,int,unitptr);
extern unitptr str_printf_unit(char*,char*,int,unitptr);
extern unitptr str_scanf_unit(char*,char*,int,unitptr);
extern unitptr switch_input_str(int,unitptr);
extern unitptr switch_output_str(int,unitptr);
extern unitptr str_to_id(char*,char*,unitptr);
extern unitptr str_to_vec(int,unitptr);
extern unitptr vec_to_str(unitptr);
extern unitptr substr_unit(unitptr);
extern unitptr insert_str_unit(unitptr);
extern unitptr str_length_unit(unitptr);
extern unitptr strtok_unit(unitptr);
extern unitptr str_subst_unit(unitptr);

#endif
