/* 
  Demo code implementing function scalar_prod() + wrapper 
  for prog_unit use. Compile this file into demolib1.so. 
  Then 

  #import "demolib1" 

  will make function float scalar_prod(float*,float*) 
  available in prog_unit.
*/

#include <stdio.h>

char *FUNCTIONS_demolib1[] = { "scalar_prod(float*,float*)", NULL};

/* 
 Implementation: parameter list is (int *piDim, void **ppvArg)
 with  piDim[i]  = dimension of i-th argument (0 = scalar)
       ppvArg[i] = address of first el of i-th argument
*/

float scalar_prod(int *piDim, void **ppvArg) {

   float *pfArg0 = (float*) ppvArg[0];  /* adr of 1st arg */
   float *pfArg1 = (float*) ppvArg[1];  /* adr of 2nd arg */
   float fReturn = 0;
printf("demolib1 %d dim=%d %d\n",__LINE__,piDim[0],piDim[1]);
printf("demolib1 %d args = %p %p\n",__LINE__,pfArg0,pfArg1);
   if (piDim[0] == piDim[1]) { int i;

printf("demolib1 %d\n",__LINE__);
       /* compute scalar product of two vectors: */
       for (i=0; i<piDim[0]; i++) fReturn += (*pfArg0++)*(*pfArg1++);
printf("demolib1 %d\n",__LINE__);

   } else fprintf(stderr,
          "dimension mismatch in scalar_prod(): %d versus %d!\n",
          piDim[0],piDim[1]);

printf("demolib1 %d\n",__LINE__);
   return fReturn;
}
 
