/**********************************************************************

  Example of two classes, implemented in plain C:

  class line:     a line object that can be added to a picture
  class point:    a point object that can be added to a picture

  They have no member functions and, therefore, just
  implement a new data type that can be used by other classes.

  The example doesn't really care to implement the suggested
  operations. It merely contains the necessary interfaces and some
  code to print info about called functions and their arguments.

***********************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "demolib5a.h"   /* import necessary type definitions */

   char *NAMESPACE = "geo";

   char *line_c[]  = {
       /* two constructors, one with initialization: */
       LINE_VERSION,  
       "_0_:", "line(void)", 
       "_1_:", "line(float,float,float,float)", 
       "__:",  "float x1", "float y1",
               "float x2", "float y2",
   NULL };

   char *point_c[] = { 
       /* two constructors, one with initialization: */ 
       POINT_VERSION,  
       "_0_:", "point(void)",
       "_1_:", "point(float,float)",
       "__:",  "float x", "float y",
   NULL};

   char **CLASSES[] = {line_c, point_c, NULL};


/*************************************************************************
  wrappers for class constructors:  
*************************************************************************/

point_t *_0_point(void) {
   point_t *pData = (point_t*) calloc(1,sizeof(point_t));
   return pData;
}

point_t *_1_point(int *piDim, void **ppvArg) {
   point_t *pData = _0_point();
   float *pfX = ppvArg[0], *pfY = ppvArg[1];
   pData->x = *pfX; pData->y = *pfY;
   return pData;
}

line_t *_0_line(void) {
   line_t *pData = (line_t*) calloc(1,sizeof(line_t));
   return pData;
}

line_t *_1_line(int *piDim, void **ppvArg) {
   float *pfX1 = ppvArg[0], *pfY1 = ppvArg[1];
   float *pfX2 = ppvArg[2], *pfY2 = ppvArg[3];
   line_t *pData = _0_line();
   pData->x1 = *pfX1; pData->y1 = *pfY1;
   pData->x2 = *pfX2; pData->y2 = *pfY2;
   return pData;
}

/*************************************************************************
  registration functions for variables:  
*************************************************************************/

float *__x(int *piDim, point_t *pData) {  return &(pData->x); }
float *__y(int *piDim, point_t *pData) {  return &(pData->y); }
float *__x1(int *piDim, line_t *pData) {  return &(pData->x1); }
float *__y1(int *piDim, line_t *pData) {  return &(pData->y1); }
float *__x2(int *piDim, line_t *pData) {  return &(pData->x2); }
float *__y2(int *piDim, line_t *pData) {  return &(pData->y2); }

